#include "scm.h"

#define STBL_VECTOR_SET(v,k,o) (v[((long)INUM(k))] = o)
#define STBL_VECTOR_REF(v,k) (v[((long)INUM(k))])
#define CHAR_LESSP(x,y) ((ICHR(x) < ICHR(y)) ? BOOL_T : BOOL_F)
#define CHAR_LEQP(x,y) ((ICHR(x) <= ICHR(y)) ? BOOL_T : BOOL_F)
#define CHCI_EQ(x,y) ((upcase[ICHR(x)]==upcase[ICHR(y)]) ? BOOL_T : BOOL_F)
#define CHCI_LESSP(x,y) ((upcase[ICHR(x)] < upcase[ICHR(y)]) ? BOOL_T : BOOL_F)
#define CHCI_LEQP(x,y) ((upcase[ICHR(x)] <= upcase[ICHR(y)]) ? BOOL_T : BOOL_F)
#define CHAR_ALPHAP(chr) ((isascii(ICHR(chr)) && isalpha(ICHR(chr))) ? BOOL_T : BOOL_F)
#define CHAR_NUMP(chr) ((isascii(ICHR(chr)) && isdigit(ICHR(chr))) ? BOOL_T : BOOL_F)
#define CHAR_WHITEP(chr) ((isascii(ICHR(chr)) && isspace(ICHR(chr))) ? BOOL_T : BOOL_F)
#define CHAR_UPPERP(chr) ((isascii(ICHR(chr)) && isupper(ICHR(chr))) ? BOOL_T : BOOL_F)
#define CHAR_LOWERP(chr) ((isascii(ICHR(chr)) && islower(ICHR(chr))) ? BOOL_T : BOOL_F)
#define CHAR2INT(chr) MAKINUM(ICHR(chr))
#define INT2CHAR(n) MAKICHR(INUM(n))
#define CHAR_UPCASE(chr) MAKICHR(upcase[ICHR(chr)])
#define CHAR_DOWNCASE(chr) MAKICHR(downcase[ICHR(chr)])
#define ST_LENGTH(str) MAKINUM(LENGTH(str))
#define ST_REF(str,k) MAKICHR(CHARS(str)[INUM(k)])
#define VECTOR_LENGTH(v)  MAKINUM(LENGTH(v))

#ifdef FLOATS
#include <math.h>
#endif
#ifdef BIGDIG
#define PRE_TRANSC_FUN(x) (INUMP(x) ? (double) INUM(x) : (REALP(x) ? (double) REALPART(x) : (double) big2dbl(x)))
#else
#define PRE_TRANSC_FUN(x) (INUMP(x) ?  (double) INUM(x) : (double) REALPART(x))
#endif

#define SIN_FUN(x) (makdbl((double) sin((double) PRE_TRANSC_FUN(x)), 0.0))
#define COS_FUN(x) (makdbl((double) cos((double) PRE_TRANSC_FUN(x)), 0.0))
#define TAN_FUN(x) (makdbl((double) tan((double) PRE_TRANSC_FUN(x)), 0.0))
#define ASIN_FUN(x) (makdbl((double) asin((double) PRE_TRANSC_FUN(x)), 0.0))
#define ACOS_FUN(x) (makdbl((double) acos((double) PRE_TRANSC_FUN(x)), 0.0))
#define ATAN_FUN(x) (makdbl((double) atan((double) PRE_TRANSC_FUN(x)), 0.0))
#define SINH_FUN(x) (makdbl((double) sinh((double) PRE_TRANSC_FUN(x)), 0.0))
#define COSH_FUN(x) (makdbl((double) cosh((double) PRE_TRANSC_FUN(x)), 0.0))
#define TANH_FUN(x) (makdbl((double) tanh((double) PRE_TRANSC_FUN(x)), 0.0))
#define ASINH_FUN(x) (makdbl((double) asinh((double) PRE_TRANSC_FUN(x)), 0.0))
#define ACOSH_FUN(x) (makdbl((double) acosh((double) PRE_TRANSC_FUN(x)), 0.0))
#define ATANH_FUN(x) (makdbl((double) atanh((double) PRE_TRANSC_FUN(x)), 0.0))
#define SQRT_FUN(x) (makdbl((double) sqrt((double) PRE_TRANSC_FUN(x)), 0.0))
#define EXPT_FUN(x,y) (makdbl((double) expt(((double) PRE_TRANSC_FUN(x)), ((double) PRE_TRANSC_FUN(y))), 0.0))
#define EXP_FUN(x) (makdbl((double) exp((double) PRE_TRANSC_FUN(x)), 0.0))
#define LOG_FUN(x) (makdbl((double) log((double) PRE_TRANSC_FUN(x)), 0.0))
#define ABS_FUN(x) (makdbl((double) fabs((double) PRE_TRANSC_FUN(x)), 0.0))

#define SBOOL(x) ((x) ? BOOL_T : BOOL_F)

#define BOOLEAN_P(x) ((x)==BOOL_T || (x)==BOOL_F)
#define CHAR_P ICHRP
#define SYMBOL_P(x) (NIMP(x) && SYMBOLP(x))
#define VECTOR_P(x) (NIMP(x) && VECTORP(x))
#define PAIR_P(x) (NIMP(x) && CONSP(x))
#define NUMBER_P INUMP
#define INTEGER_P INUMP
#define STRING_P(x) (NIMP(x) && STRINGP(x))
#define NULL_P NULLP

/* These 3 definitions are immediate integer only */
#define ZERO_P(x) ((x)==INUM0)
#define POSITIVE_P(x) ((x) > INUM0)
#define NEGATIVE_P(x) ((x) < INUM0)

#define SET_CAR(x,y) (CAR(x) = (SCM)(y))
#define SET_CDR(x,y) (CDR(x) = (SCM)(y))
#define VECTOR_SET(v,k,o) (VELTS(v)[((long)INUM(k))] = (o))
#define VECTOR_REF(v,k) (VELTS(v)[((long)INUM(k))])
#define GLOBAL(x) (*(x))

#define append2(lst1,lst2) (append(cons2(lst1,lst2,EOL)))
#define procedure_pred_(x) (BOOL_T==procedurep(x))
